package com.bcxin.identity.domains.entities;

import com.bcxin.Infrastructures.utils.UUIDUtil;
import com.bcxin.identity.domains.enums.PrincipalStatus;
import com.bcxin.identity.domains.events.IdentityUser_WechatBindEvent;
import lombok.AccessLevel;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.sql.Timestamp;
import java.time.Instant;

@Getter
@Setter(AccessLevel.PROTECTED)
@Entity
@Table(name = "identity_wechat")
public class WechatPrincipalEntity extends PrincipalAbstract {
    @Column(name = "openId", nullable = false,length = 200)
    private String openId;
    @Column(name = "nicky", nullable = true,length = 50)
    private String nicky;
    @Column(name = "union_id")
    private String unionId;

    protected WechatPrincipalEntity() {

    }

    public static WechatPrincipalEntity create(
            IdentityUserEntity identityUser, String openId, String nicky, String unionId) {
        return create(identityUser, UUIDUtil.getShortUuid(), openId, nicky, unionId);
    }

    public static WechatPrincipalEntity create(
            IdentityUserEntity identityUser, String id, String openId, String nicky, String unionId) {

        WechatPrincipalEntity principal = new WechatPrincipalEntity();

        principal.setId(UUIDUtil.getShortUuid());
        principal.setIdentityUser(identityUser);
        principal.setOpenId(openId);
        principal.setNicky(nicky);
        principal.setUnionId(unionId);
        principal.setStatus(PrincipalStatus.ACTIVATE);

        principal.recordEvent(
                IdentityUser_WechatBindEvent.create(
                        identityUser.getTenantUserId(),
                        principal.getOpenId(),
                        principal.getNicky())
        );

        return principal;
    }
}
